Index: trunk/src/lib/particles/particle_system.cc
===================================================================
--- trunk/src/lib/particles/particle_system.cc	(revision 9391)
+++ trunk/src/lib/particles/particle_system.cc	(revision 9406)
@@ -32,5 +32,5 @@
 #include <algorithm>
 
-using namespace std;
+
 /**
  *  standard constructor
@@ -139,5 +139,5 @@
       {
         PRINTF(2)("Tried to load an Element of type '%s' that should be a ParticleEmitter onto '%s::%s'.\n",
-                  emitter->getClassName(), this->getClassName(), this->getName());
+                  emitter->getClassCName(), this->getClassCName(), this->getCName());
         delete emitter;
       }
@@ -145,5 +145,5 @@
     else
     {
-      PRINTF(2)("Could not Generate Emitter for system %s::%s (wrong type in XML-format)\n", this->getClassName(), getName());
+      PRINTF(2)("Could not Generate Emitter for system %s::%s (wrong type in XML-format)\n", this->getClassCName(), getCName());
     }
   }
@@ -157,5 +157,5 @@
 {
   this->maxCount = maxCount;
-  PRINTF(4)("MAXCOUNT of %s::%s is %d\n", this->getClassName(), this->getName(),maxCount);
+  PRINTF(4)("MAXCOUNT of %s::%s is %d\n", this->getClassCName(), this->getCName(), maxCount);
 }
 
@@ -170,5 +170,5 @@
   this->lifeSpan = lifeSpan;
   this->randomLifeSpan = randomLifeSpan;
-  PRINTF(4)("LifeTime of %s::%s is %f\n", this->getClassName(), this->getName(), lifeSpan);
+  PRINTF(4)("LifeTime of %s::%s is %f\n", this->getClassCName(), this->getCName(), lifeSpan);
 }
 
@@ -188,5 +188,5 @@
     this->conserve = conserve;
 
-  PRINTF(4)("Conserve of %s::%s is %f\n", this->getClassName(), this->getName(),conserve);
+  PRINTF(4)("Conserve of %s::%s is %f\n", this->getClassCName(), this->getCName(), conserve);
 }
 
@@ -206,5 +206,5 @@
 
   PRINTF(4)("Radius of %s::%s at timeSlice %f is %f with a Random of %f\n",
-    this->getClassName(), this->getName(),lifeCycleTime, radius, randRadius);
+    this->getClassCName(), this->getCName(), lifeCycleTime, radius, randRadius);
 }
 
@@ -237,5 +237,5 @@
 
   PRINTF(4)("Color of %s::%s on timeslice %f is r:%f g:%f b:%f a:%f\n",
-    this->getClassName(), this->getName(), lifeCycleTime, red, green, blue, alpha);
+    this->getClassCName(), this->getCName(), lifeCycleTime, red, green, blue, alpha);
 }
 
@@ -278,5 +278,5 @@
     (*emitter)->updateNode(.1), (*emitter)->updateNode(.1);
 
-  PRINTF(4)("Precaching %s::%s %d seconds %d timesPerSecond\n", this->getClassName(), this->getName(), seconds, ticksPerSecond);
+  PRINTF(4)("Precaching %s::%s %d seconds %d timesPerSecond\n", this->getClassCName(), this->getCName(), seconds, ticksPerSecond);
   for (unsigned int i = 0; i < seconds*ticksPerSecond; i++)
     this->tick(1.0/(float)ticksPerSecond);
@@ -460,5 +460,5 @@
     int i = 1;
     Particle* tmpPart = this->deadList;
-    while (tmpPart = tmpPart->next) { ++i; }
+    while ((tmpPart = tmpPart->next) != NULL) { ++i; }
     PRINT(0)("count: %d\n", i);
   }
Index: trunk/src/lib/particles/plane_emitter.cc
===================================================================
--- trunk/src/lib/particles/plane_emitter.cc	(revision 9391)
+++ trunk/src/lib/particles/plane_emitter.cc	(revision 9406)
@@ -25,5 +25,5 @@
 #include "stdlibincl.h"
 
-using namespace std;
+
 
 
Index: trunk/src/lib/particles/quick_animation.cc
===================================================================
--- trunk/src/lib/particles/quick_animation.cc	(revision 9391)
+++ trunk/src/lib/particles/quick_animation.cc	(revision 9406)
@@ -20,5 +20,5 @@
 #include <algorithm>
 
-using namespace std;
+
 
 /**
Index: trunk/src/lib/particles/spark_particles.cc
===================================================================
--- trunk/src/lib/particles/spark_particles.cc	(revision 9391)
+++ trunk/src/lib/particles/spark_particles.cc	(revision 9406)
@@ -29,5 +29,5 @@
 
 
-using namespace std;
+
 
 CREATE_FACTORY(SparkParticles, CL_SPARK_PARTICLES);
Index: trunk/src/lib/particles/sprite_particles.cc
===================================================================
--- trunk/src/lib/particles/sprite_particles.cc	(revision 9391)
+++ trunk/src/lib/particles/sprite_particles.cc	(revision 9406)
@@ -33,5 +33,5 @@
     ->defaultValues("maps/evil-flower.png");
 
-using namespace std;
+
 
 /**
Index: trunk/src/lib/physics/fields/field.cc
===================================================================
--- trunk/src/lib/physics/fields/field.cc	(revision 9391)
+++ trunk/src/lib/physics/fields/field.cc	(revision 9406)
@@ -22,5 +22,5 @@
 #include "util/loading/factory.h"
 #include "util/loading/load_param.h"
-using namespace std;
+
 
 /**
Index: trunk/src/lib/physics/fields/gravity.cc
===================================================================
--- trunk/src/lib/physics/fields/gravity.cc	(revision 9391)
+++ trunk/src/lib/physics/fields/gravity.cc	(revision 9406)
@@ -21,5 +21,5 @@
 #include "util/loading/factory.h"
 
-using namespace std;
+
 
 CREATE_FACTORY(Gravity, CL_FIELD_GRAVITY);
Index: trunk/src/lib/physics/fields/point_gravity.cc
===================================================================
--- trunk/src/lib/physics/fields/point_gravity.cc	(revision 9391)
+++ trunk/src/lib/physics/fields/point_gravity.cc	(revision 9406)
@@ -18,5 +18,5 @@
 #include "point_gravity.h"
 
-using namespace std;
+
 
 
Index: trunk/src/lib/physics/fields/twirl.cc
===================================================================
--- trunk/src/lib/physics/fields/twirl.cc	(revision 9391)
+++ trunk/src/lib/physics/fields/twirl.cc	(revision 9406)
@@ -18,5 +18,5 @@
 #include "twirl.h"
 
-using namespace std;
+
 
 
Index: trunk/src/lib/physics/physics_connection.cc
===================================================================
--- trunk/src/lib/physics/physics_connection.cc	(revision 9391)
+++ trunk/src/lib/physics/physics_connection.cc	(revision 9406)
@@ -27,5 +27,5 @@
 #include "util/loading/load_param.h"
 
-using namespace std;
+
 
 CREATE_FACTORY(PhysicsConnection, CL_PHYSICS_CONNECTION);
@@ -81,5 +81,5 @@
   }
   else
-    PRINTF(5)("subject::%s\n", this->subject->getName());
+    PRINTF(5)("subject::%s\n", this->subject->getCName());
 }
 
@@ -95,5 +95,5 @@
   }
   else
-    PRINTF(5)("field::%s\n", this->field->getName());
+    PRINTF(5)("field::%s\n", this->field->getCName());
 
 }
Index: trunk/src/lib/physics/physics_engine.cc
===================================================================
--- trunk/src/lib/physics/physics_engine.cc	(revision 9391)
+++ trunk/src/lib/physics/physics_engine.cc	(revision 9406)
@@ -23,5 +23,5 @@
 #include "util/loading/load_param.h"
 
-using namespace std;
+
 
 
@@ -162,5 +162,5 @@
 Field* PhysicsEngine::getFieldByName(const std::string& fieldName) const
 {
-  list<Field*>::const_iterator field;
+  std::list<Field*>::const_iterator field;
   for (field = this->fields.begin(); field != this->fields.end(); field++)
     if (fieldName == (*field)->getName())
@@ -199,5 +199,5 @@
 PhysicsConnection* PhysicsEngine::getPhysicsConnectionByName(const std::string& physicsConnectionName) const
 {
-  list<PhysicsConnection*>::const_iterator pc;
+  std::list<PhysicsConnection*>::const_iterator pc;
   for (pc = this->connections.begin(); pc != this->connections.end(); pc++)
     if (physicsConnectionName == (*pc)->getName())
@@ -218,5 +218,5 @@
   /* go through all the PhysicsInterface(s) and tick them,
   meaning let the fields work */
-  list<PhysicsConnection*>::iterator pc;
+  std::list<PhysicsConnection*>::iterator pc;
   for (pc = this->connections.begin(); pc != this->connections.end(); pc++)
     (*pc)->apply();
@@ -225,5 +225,5 @@
   if (this->interfaces != NULL || (this->interfaces = ClassList::getList(CL_PHYSICS_INTERFACE)) != NULL)
   {
-    list<BaseObject*>::const_iterator tickPhys;
+    std::list<BaseObject*>::const_iterator tickPhys;
     for (tickPhys = this->interfaces->begin(); tickPhys != this->interfaces->end(); tickPhys++)
       dynamic_cast<PhysicsInterface*>(*tickPhys)->tickPhys(dt);
Index: trunk/src/lib/physics/physics_interface.cc
===================================================================
--- trunk/src/lib/physics/physics_interface.cc	(revision 9391)
+++ trunk/src/lib/physics/physics_interface.cc	(revision 9406)
@@ -29,5 +29,5 @@
 #include "stdincl.h"
 
-using namespace std;
+
 
 
@@ -68,5 +68,5 @@
     {
     // todo: find out if children are PhysicsInterface in an efficient way
-    if (strcmp( pn->getClassName(), "PhysicsInterface")) {
+    if (strcmp( pn->getClassCName(), "PhysicsInterface")) {
     massSum += ((PhysicsInterface*)pn)->getTotalMass();
     }
@@ -77,5 +77,5 @@
     if (massSum != this->massChildren ) {
     this->massChildren = massSum;
-    if (strcmp( massCalcPNode->parent->getClassName(), "PhysicsInterface"))
+    if (strcmp( massCalcPNode->parent->getClassCName(), "PhysicsInterface"))
     ((PhysicsInterface*)massCalcPNode->parent)->recalcMass();
     } else {
Index: trunk/src/lib/shell/shell_command.cc
===================================================================
--- trunk/src/lib/shell/shell_command.cc	(revision 9391)
+++ trunk/src/lib/shell/shell_command.cc	(revision 9406)
@@ -119,7 +119,9 @@
 
     CmdList::const_iterator elem;
-    for (elem = cmdClass->commandList.begin(); elem != cmdClass->commandList.end(); elem++)
-      if (commandName == (*elem)->getName())
-        return (*elem);
+    for (unsigned int i = 0; i < cmdClass->commandList.size(); i++)
+    {
+      if (commandName == cmdClass->commandList[i]->getName())
+        return (cmdClass->commandList[i]);
+    }
     return NULL;
   }
@@ -137,5 +139,6 @@
     if (likely(checkClass != NULL))
       return ShellCommand::getCommand(commandName, checkClass);
-    return NULL;
+    else
+      return NULL;
   }
 
@@ -149,5 +152,5 @@
   const ShellCommand* const ShellCommand::getCommandFromInput(const std::string& inputLine, unsigned int& paramBegin, std::vector<BaseObject*>* boList)
   {
-    return ShellCommand::getCommandFromInput(SubString(inputLine, SubString::WhiteSpaces), paramBegin);
+    return ShellCommand::getCommandFromInput(SubString(inputLine, SubString::WhiteSpaces), paramBegin, boList);
   }
 
@@ -199,5 +202,5 @@
       {
         // Search for Objects.
-        retCmd = ShellCommand::getCommand(strings[1], cmdClass);
+        retCmd = ShellCommand::getCommand((strings.size() > 1) ? strings[1] : "", cmdClass);
         if (retCmd != NULL)
         {
@@ -210,5 +213,5 @@
       if (retCmd == NULL && strings.size() >= 2)
       {
-        retCmd = ShellCommand::getCommand(strings[2], cmdClass);
+        retCmd = ShellCommand::getCommand((strings.size() > 2) ? strings[2] : "", cmdClass);
         if (retCmd != NULL)
         {
@@ -254,5 +257,5 @@
       {
         for (bo = objectList->begin(); bo != objectList->end(); bo++)
-          if ((*bo)->getName() != NULL && !nocaseCmp(objectDescriptor, (*bo)->getName(), objectDescriptor.size()))
+          if (!nocaseCmp(objectDescriptor, (*bo)->getName(), objectDescriptor.size()))
             boList->push_back(*bo);
       }
@@ -298,6 +301,6 @@
       for(std::vector<BaseObject*>::const_iterator bo = boList.begin(); bo != boList.end(); ++bo)
       {
-        PRINT(0)("Command '%s' on '%s::%s'\n", sc->getName(), (*bo)->getClassName(), (*bo)->getName());
-        (*sc->executor)((*bo), inputSplits.getSubSet(paramBegin));
+        PRINT(0)("Command '%s' on '%s::%s'\n", sc->getCName(), (*bo)->getClassCName(), (*bo)->getCName());
+        (*sc->executor)((*bo), inputSplits.subSet(paramBegin));
       }
       return true;
@@ -331,5 +334,5 @@
     if (this->alias != NULL)
     {
-      PRINTF(2)("not more than one Alias allowed for functions (%s::%s)\n", this->getName(), this->shellClass->getName());
+      PRINTF(2)("not more than one Alias allowed for functions (%s::%s)\n", this->getCName(), this->shellClass->getCName());
     }
     else
@@ -369,5 +372,5 @@
     {
       PRINTF(1)("Parameter %d not inside of valid ParameterCount %d of Command %s::%s\n",
-                parameter, this->executor->getParamCount(), this->getName(), this->shellClass->getName());
+                parameter, this->executor->getParamCount(), this->getCName(), this->shellClass->getCName());
     }
     else
@@ -375,5 +378,5 @@
 //       if(this->completors[parameter] == NULL)
 //       delete this->completors[parameter];
-//       this->completors[parameter] = completorPlugin.clone(); 
+//       this->completors[parameter] = completorPlugin.clone();
     }
     return this;
@@ -385,5 +388,5 @@
   void ShellCommand::help() const
   {
-    PRINT(0)("%s ", this->getName());
+    PRINT(0)("%s ", this->getCName());
   }
 
Index: trunk/src/lib/shell/shell_command_class.cc
===================================================================
--- trunk/src/lib/shell/shell_command_class.cc	(revision 9391)
+++ trunk/src/lib/shell/shell_command_class.cc	(revision 9406)
@@ -199,5 +199,5 @@
         for (cmdIT = (*classIT)->commandList.begin(); cmdIT != (*classIT)->commandList.end(); cmdIT++)
         {
-          PRINT(0)("  command:'%s' : params:%d: ", (*cmdIT)->getName(), (*cmdIT)->executor->getParamCount());
+          PRINT(0)("  command:'%s' : params:%d: ", (*cmdIT)->getCName(), (*cmdIT)->executor->getParamCount());
           /// FIXME
           /*          for (unsigned int i = 0; i< elem->paramCount; i++)
Index: trunk/src/lib/shell/shell_completion.cc
===================================================================
--- trunk/src/lib/shell/shell_completion.cc	(revision 9391)
+++ trunk/src/lib/shell/shell_completion.cc	(revision 9406)
@@ -290,6 +290,5 @@
     for(bo = inputList.begin(); bo != inputList.end(); bo++)
     {
-      if ((*bo)->getName() != NULL &&
-          strlen((*bo)->getName()) >= searchLength &&
+      if ((*bo)->getName().size() >= searchLength &&
           !nocaseCmp((*bo)->getName(), completionBegin, searchLength))
       {
Index: trunk/src/lib/sound/ogg_player.cc
===================================================================
--- trunk/src/lib/sound/ogg_player.cc	(revision 9391)
+++ trunk/src/lib/sound/ogg_player.cc	(revision 9406)
@@ -481,5 +481,5 @@
     if (comment == NULL)
     {
-      PRINTF(2)("Retrieving Comment of %s failed\n", this->getName());
+      PRINTF(2)("Retrieving Comment of %s failed\n", this->getCName());
       return;
     }
Index: trunk/src/lib/util/Makefile.am
===================================================================
--- trunk/src/lib/util/Makefile.am	(revision 9391)
+++ trunk/src/lib/util/Makefile.am	(revision 9406)
@@ -6,5 +6,4 @@
 libORXlibutil_a_SOURCES = \
 		substring.cc \
-		tokenizer.cc \
 		color.cc \
 		helper_functions.cc \
@@ -24,4 +23,5 @@
 		filesys/file.cc \
 		filesys/directory.cc \
+		filesys/net_link.cc \
 		\
 		preferences.cc \
@@ -32,5 +32,4 @@
 noinst_HEADERS = \
 		substring.h \
-		tokenizer.h \
 		multi_type.h \
 		color.h \
@@ -44,4 +43,5 @@
 		filesys/file.h \
 		filesys/directory.h \
+		filesys/net_link.h \
 		\
 		preferences.h \
Index: trunk/src/lib/util/executor/executor_functional.h
===================================================================
--- trunk/src/lib/util/executor/executor_functional.h	(revision 9391)
+++ trunk/src/lib/util/executor/executor_functional.h	(revision 9406)
@@ -179,5 +179,5 @@
   {
     (__EXECUTOR_FUNCTIONAL_FUNCTION_EXEC)(
-      fromString<type0>(sub[0], getDefault<type0>(this->defaultValue, 0)) );
+      (sub.size() > 0) ? fromString<type0>(sub[0], getDefault<type0>(this->defaultValue, 0)) : (fromMulti<type0>(this->defaultValue[0])));
   };
 
@@ -222,6 +222,6 @@
   {
     (__EXECUTOR_FUNCTIONAL_FUNCTION_EXEC)(
-      fromString<type0>(sub[0], getDefault<type0>(this->defaultValue, 0)),
-      fromString<type1>(sub[1], getDefault<type1>(this->defaultValue, 1)));
+      (sub.size() > 0) ? fromString<type0>(sub[0], getDefault<type0>(this->defaultValue, 0)) : (fromMulti<type0>(this->defaultValue[0])),
+      (sub.size() > 1) ? fromString<type1>(sub[1], getDefault<type1>(this->defaultValue, 1)) : (fromMulti<type1>(this->defaultValue[1])));
   };
 
@@ -276,7 +276,7 @@
   {
     (__EXECUTOR_FUNCTIONAL_FUNCTION_EXEC)(
-      fromString<type0>(sub[0], getDefault<type0>(this->defaultValue, 0)),
-      fromString<type1>(sub[1], getDefault<type1>(this->defaultValue, 1)),
-      fromString<type2>(sub[2], getDefault<type2>(this->defaultValue, 2)));
+      (sub.size() > 0) ? fromString<type0>(sub[0], getDefault<type0>(this->defaultValue, 0)) : (fromMulti<type0>(this->defaultValue[0])),
+      (sub.size() > 1) ? fromString<type1>(sub[1], getDefault<type1>(this->defaultValue, 1)) : (fromMulti<type1>(this->defaultValue[1])),
+      (sub.size() > 2) ? fromString<type2>(sub[2], getDefault<type2>(this->defaultValue, 2)) : (fromMulti<type2>(this->defaultValue[2])));
   };
 
@@ -333,8 +333,8 @@
   {
     (__EXECUTOR_FUNCTIONAL_FUNCTION_EXEC)(
-      fromString<type0>(sub[0], getDefault<type0>(this->defaultValue, 0)),
-      fromString<type1>(sub[1], getDefault<type1>(this->defaultValue, 1)),
-      fromString<type2>(sub[2], getDefault<type2>(this->defaultValue, 2)),
-      fromString<type3>(sub[3], getDefault<type3>(this->defaultValue, 3)));
+      (sub.size() > 0) ? fromString<type0>(sub[0], getDefault<type0>(this->defaultValue, 0)) : (fromMulti<type0>(this->defaultValue[0])),
+      (sub.size() > 1) ? fromString<type1>(sub[1], getDefault<type1>(this->defaultValue, 1)) : (fromMulti<type1>(this->defaultValue[1])),
+      (sub.size() > 2) ? fromString<type2>(sub[2], getDefault<type2>(this->defaultValue, 2)) : (fromMulti<type2>(this->defaultValue[2])),
+      (sub.size() > 3) ? fromString<type3>(sub[3], getDefault<type3>(this->defaultValue, 3)) : (fromMulti<type3>(this->defaultValue[3])));
   };
 
@@ -392,9 +392,9 @@
   {
     (__EXECUTOR_FUNCTIONAL_FUNCTION_EXEC)(
-      fromString<type0>(sub[0], getDefault<type0>(this->defaultValue, 0)),
-      fromString<type1>(sub[1], getDefault<type1>(this->defaultValue, 1)),
-      fromString<type2>(sub[2], getDefault<type2>(this->defaultValue, 2)),
-      fromString<type3>(sub[3], getDefault<type3>(this->defaultValue, 3)),
-      fromString<type4>(sub[4], getDefault<type4>(this->defaultValue, 4)));
+      (sub.size() > 0) ? fromString<type0>(sub[0], getDefault<type0>(this->defaultValue, 0)) : (fromMulti<type0>(this->defaultValue[0])),
+      (sub.size() > 1) ? fromString<type1>(sub[1], getDefault<type1>(this->defaultValue, 1)) : (fromMulti<type1>(this->defaultValue[1])),
+      (sub.size() > 2) ? fromString<type2>(sub[2], getDefault<type2>(this->defaultValue, 2)) : (fromMulti<type2>(this->defaultValue[2])),
+      (sub.size() > 3) ? fromString<type3>(sub[3], getDefault<type3>(this->defaultValue, 3)) : (fromMulti<type3>(this->defaultValue[3])),
+      (sub.size() > 4) ? fromString<type4>(sub[4], getDefault<type4>(this->defaultValue, 4)) : (fromMulti<type4>(this->defaultValue[4])));
   };
 
Index: trunk/src/lib/util/executor/functor_list.h
===================================================================
--- trunk/src/lib/util/executor/functor_list.h	(revision 9391)
+++ trunk/src/lib/util/executor/functor_list.h	(revision 9406)
@@ -135,4 +135,5 @@
 
   //! mixed values:
+  FUNCTOR_LIST(2)(l_STRING, l_INT);
   FUNCTOR_LIST(2)(l_STRING, l_FLOAT);
   FUNCTOR_LIST(2)(l_UINT, l_LONG);
Index: trunk/src/lib/util/filesys/net_link.cc
===================================================================
--- trunk/src/lib/util/filesys/net_link.cc	(revision 9406)
+++ trunk/src/lib/util/filesys/net_link.cc	(revision 9406)
@@ -0,0 +1,83 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+### File Specific:
+   main-programmer: Benjamin Grauer
+   co-programmer: ...
+*/
+
+#include "net_link.h"
+#include "debug.h"
+
+
+#ifdef __OSX__
+#include <ApplicationServices/ApplicationServices.h>
+#elif defined __WIN32__
+//#include <shellapi.h>
+#endif
+
+
+NetLink::NetLink(const std::string& linkName)
+{
+  this->_link = linkName;
+}
+
+
+void NetLink::openInBrowser() const
+{
+  SDL_CreateThread(NetLink::openupInBrowser, (void*)&this->_link);
+}
+
+OrxThread::Mutex NetLink::_mutex;
+std::string NetLink::_defaultBrowser = "firefox";
+std::list<std::string> NetLink::_browserList = NetLink::buildBrowserList();
+
+
+
+
+int NetLink::openupInBrowser(void* url)
+{
+  OrxThread::MutexLock lock(&NetLink::_mutex);
+
+  std::string URL = *(std::string*)url;
+#ifdef __linux__
+  system ((std::string(NetLink::defaultBrowser()) + " " + URL).c_str());
+
+#elif defined __OSX__
+  CFURLRef url_handle = CFURLCreateWithBytes (NULL, (UInt8 *)URL.c_str(), URL.size(),
+                                              kCFStringEncodingASCII, NULL);
+  LSOpenCFURLRef (url_handle, NULL);
+  CFRelease (url_handle);
+
+#elif defined __WIN32__
+  /*  ShellExecute(GetActiveWindow(),
+               "open", URL.c_str(), NULL, NULL, SW_SHOWNORMAL);
+}*/
+#endif
+  PRINTF(3)("loaded external webpage %s\n", URL.c_str());
+
+  return 0;
+}
+
+void NetLink::setDefaultBrowser(const std::string& browserName)
+{
+  OrxThread::MutexLock lock(&NetLink::_mutex);
+  NetLink::_defaultBrowser = browserName;
+}
+
+std::list<std::string> NetLink::buildBrowserList()
+{
+  std::list<std::string> browserList;
+  browserList.push_back("firefox");
+  browserList.push_back("mozilla");
+  browserList.push_back("konqueror");
+
+  return  browserList;
+}
Index: trunk/src/lib/util/filesys/net_link.h
===================================================================
--- trunk/src/lib/util/filesys/net_link.h	(revision 9406)
+++ trunk/src/lib/util/filesys/net_link.h	(revision 9406)
@@ -0,0 +1,53 @@
+/*!
+ * @file net_link.h
+ * @brief Definition of a NetLink class
+ * NetLink is a File link to a page of file link to the Internet,
+ * or the local file-system
+ *
+ * Opening a link should be made easy through this class
+ *
+ * !! DANGER IT IS POSSIBLE TO EXECUTE ALL PROGRAMMS WITH USER'S RIGHTS
+ * !! ON THE DESIGNATED MACHINE
+ * !! THIS CLASS SHOULD BE USED WITH CAUTION WHEN USING OVER IN NETWORK
+ * !! MODE
+ */
+
+#ifndef __NET_LINK_H__
+#define __NET_LINK_H__
+
+#include <string>
+#include <list>
+
+#include "threading.h"
+
+//! NetLink is a File and Link executer for Internet Links
+/**
+ * @example: NetLink("http://www.orxonox.net").openInBrowser();
+ */
+class NetLink
+{
+public:
+  NetLink(const std::string& linkName);
+
+  void openInBrowser() const;
+
+  static void setDefaultBrowser(const std::string& browserName);
+  static const std::string& defaultBrowser() {  return NetLink::_defaultBrowser; };
+
+private:
+  static int openupInBrowser(void* url);
+
+  static std::list<std::string> buildBrowserList();
+
+
+private:
+  std::string                     _link;             //!< Linkname
+
+
+  // static lists.
+  static OrxThread::Mutex         _mutex;            //!< One mutex to lock them all.
+  static std::string              _defaultBrowser;   //!< The default Browser.
+  static std::list<std::string>   _browserList;
+};
+
+#endif /** __NET_LINK_H__ */
Index: trunk/src/lib/util/helper_functions.cc
===================================================================
--- trunk/src/lib/util/helper_functions.cc	(revision 9391)
+++ trunk/src/lib/util/helper_functions.cc	(revision 9406)
@@ -19,5 +19,5 @@
 #include "stdlibincl.h"
 
-using namespace std;
+
 
 /**
Index: trunk/src/lib/util/loading/dynamic_loader.cc
===================================================================
--- trunk/src/lib/util/loading/dynamic_loader.cc	(revision 9391)
+++ trunk/src/lib/util/loading/dynamic_loader.cc	(revision 9406)
@@ -23,5 +23,5 @@
 
 
-using namespace std;
+
 
 
Index: trunk/src/lib/util/loading/factory.cc
===================================================================
--- trunk/src/lib/util/loading/factory.cc	(revision 9391)
+++ trunk/src/lib/util/loading/factory.cc	(revision 9406)
@@ -19,5 +19,5 @@
 //#include "shell_command.h"
 
-using namespace std;
+
 
 //SHELL_COMMAND(create, Factory, fabricate);
@@ -117,5 +117,5 @@
   if (factory != Factory::factoryList->end())
   {
-    PRINTF(2)("Create a new Object of type %s\n", (*factory)->getName());
+    PRINTF(2)("Create a new Object of type %s\n", (*factory)->getCName());
     return (*factory)->fabricateObject(root);
   }
@@ -145,5 +145,5 @@
   if (factory != Factory::factoryList->end())
   {
-    PRINTF(4)("Create a new Object of type %s\n", (*factory)->getName());
+    PRINTF(4)("Create a new Object of type %s\n", (*factory)->getCName());
     return (*factory)->fabricateObject(NULL);
   }
@@ -173,5 +173,5 @@
   if (factory != Factory::factoryList->end())
   {
-    PRINTF(4)("Create a new Object of type %s\n", (*factory)->getName());
+    PRINTF(4)("Create a new Object of type %s\n", (*factory)->getCName());
     return (*factory)->fabricateObject(NULL);
   }
Index: trunk/src/lib/util/loading/load_param.cc
===================================================================
--- trunk/src/lib/util/loading/load_param.cc	(revision 9391)
+++ trunk/src/lib/util/loading/load_param.cc	(revision 9406)
@@ -65,5 +65,5 @@
           ((this->executor->getType() & Executor_NoLoadString) == Executor_NoLoadString)))
     {
-      PRINTF(4)("Loading value '%s' with Parameters '%s' onto: %s::%s\n", this->paramName.c_str(), loadString.c_str(), this->object->getClassName(), this->object->getName());
+      PRINTF(4)("Loading value '%s' with Parameters '%s' onto: %s::%s\n", this->paramName.c_str(), loadString.c_str(), this->object->getClassCName(), this->object->getCName());
       (*this->executor)(this->object, SubString(loadString, ",", SubString::WhiteSpaces, false, '\\'));
     }
@@ -164,5 +164,5 @@
 {
     // locating the class
-    this->classDesc = LoadClassDescription::addClass(object->getClassName());
+    this->classDesc = LoadClassDescription::addClass(object->getClassCName());
 
     if ((this->paramDesc = this->classDesc->addParam(paramName)) != NULL)
Index: trunk/src/lib/util/loading/resource.cc
===================================================================
--- trunk/src/lib/util/loading/resource.cc	(revision 9391)
+++ trunk/src/lib/util/loading/resource.cc	(revision 9406)
@@ -18,5 +18,5 @@
 #include "resource.h"
 
-using namespace std;
+
 
 
Index: trunk/src/lib/util/loading/resource_manager.cc
===================================================================
--- trunk/src/lib/util/loading/resource_manager.cc	(revision 9391)
+++ trunk/src/lib/util/loading/resource_manager.cc	(revision 9406)
@@ -50,5 +50,5 @@
 #include <unistd.h>
 
-using namespace std;
+
 
 /**
Index: trunk/src/lib/util/multi_type.cc
===================================================================
--- trunk/src/lib/util/multi_type.cc	(revision 9391)
+++ trunk/src/lib/util/multi_type.cc	(revision 9406)
@@ -18,9 +18,4 @@
 #include "multi_type.h"
 
-//#include "stdincl.h"
-#include <stddef.h>
-#include <stdlib.h>
-#include <string.h>
-#include <stdio.h>
 #include <sstream>
 
@@ -28,6 +23,4 @@
 #include "debug.h"
 #endif
-
-using namespace std;
 
 /**
